package com.example.demo.coupon.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.coupon.domain.Coupon;
import com.example.demo.coupon.dto.PageDto;
import com.example.demo.coupon.service.CouponService;
import com.example.demo.coupon.dao.CouponMapper;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
* @author 徐乐
* @description 针对表【coupon(优惠券主表)】的数据库操作Service实现
* @createDate 2025-06-17 18:40:22
*/
@Service
public class CouponServiceImpl extends ServiceImpl<CouponMapper, Coupon>
    implements CouponService{
    @Autowired
    private CouponMapper couponMapper;

    @Override
    public ResultVo getCouponList(PageDto dto, String token) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        Page<Coupon> page = new Page<>(dto.getPageNum(),dto.getPageSize());
        QueryWrapper<Coupon> queryWrapper = new QueryWrapper<>();
        couponMapper.selectPage(page,queryWrapper);
        List<Coupon> couponList = page.getRecords();
        return ResultVo.success(couponList);
    }
}




