package com.example.demo.order.controller;

import com.example.demo.order.dto.OrderInfoDto;
import com.example.demo.order.dto.OrderInfoUpDto;
import com.example.demo.order.service.impl.OrderInfoServiceImpl;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/order")
public class OrderController {
    @Autowired
    private OrderInfoServiceImpl orderInfoService;
    @RequestMapping("/orderAdd")
    public ResultVo orderAdd(@RequestBody OrderInfoDto dto,@RequestHeader("token") String token){
        return orderInfoService.orderAdd(dto,token);
    }
    @RequestMapping("/orderUp")
    public ResultVo orderUp(@RequestBody OrderInfoUpDto dto, @RequestHeader("token") String token){
        return orderInfoService.orderUp(dto,token);
    }
    @RequestMapping("/orderGetList")
    public ResultVo orderGetList(@RequestHeader("token") String token){
        return orderInfoService.orderGetList(token);
    }
    @RequestMapping("/pay/{orderId}")
    public ResultVo orderPay(@PathVariable("orderId") Long orderId,
                            @RequestParam("paymentMethod") Integer paymentMethod,
                            HttpServletRequest request) {
        String token = request.getHeader("token");
        return orderInfoService.orderPay(orderId, paymentMethod, token);
    }
}
