package com.example.demo.product.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.util.Date;
import lombok.Data;

/**
 * 车票产品扩展信息表
 * @TableName product_train
 */
@TableName(value ="product_train")
@Data
public class ProductTrain {
    /**
     * 车票产品ID
     */
    @TableId
    private Long id;

    /**
     * 关联产品主表ID
     */
    private Long productId;

    /**
     * 车次
     */
    private String trainNo;

    /**
     * 出发站
     */
    private String departureStation;

    /**
     * 到达站
     */
    private String arrivalStation;

    /**
     * 出发时间
     */
    private Date departureTime;

    /**
     * 到达时间
     */
    private Date arrivalTime;

    /**
     * 座位类型（如“硬座”“软卧”）
     */
    private String seatType;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        ProductTrain other = (ProductTrain) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getProductId() == null ? other.getProductId() == null : this.getProductId().equals(other.getProductId()))
            && (this.getTrainNo() == null ? other.getTrainNo() == null : this.getTrainNo().equals(other.getTrainNo()))
            && (this.getDepartureStation() == null ? other.getDepartureStation() == null : this.getDepartureStation().equals(other.getDepartureStation()))
            && (this.getArrivalStation() == null ? other.getArrivalStation() == null : this.getArrivalStation().equals(other.getArrivalStation()))
            && (this.getDepartureTime() == null ? other.getDepartureTime() == null : this.getDepartureTime().equals(other.getDepartureTime()))
            && (this.getArrivalTime() == null ? other.getArrivalTime() == null : this.getArrivalTime().equals(other.getArrivalTime()))
            && (this.getSeatType() == null ? other.getSeatType() == null : this.getSeatType().equals(other.getSeatType()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getProductId() == null) ? 0 : getProductId().hashCode());
        result = prime * result + ((getTrainNo() == null) ? 0 : getTrainNo().hashCode());
        result = prime * result + ((getDepartureStation() == null) ? 0 : getDepartureStation().hashCode());
        result = prime * result + ((getArrivalStation() == null) ? 0 : getArrivalStation().hashCode());
        result = prime * result + ((getDepartureTime() == null) ? 0 : getDepartureTime().hashCode());
        result = prime * result + ((getArrivalTime() == null) ? 0 : getArrivalTime().hashCode());
        result = prime * result + ((getSeatType() == null) ? 0 : getSeatType().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", productId=").append(productId);
        sb.append(", trainNo=").append(trainNo);
        sb.append(", departureStation=").append(departureStation);
        sb.append(", arrivalStation=").append(arrivalStation);
        sb.append(", departureTime=").append(departureTime);
        sb.append(", arrivalTime=").append(arrivalTime);
        sb.append(", seatType=").append(seatType);
        sb.append("]");
        return sb.toString();
    }
}