package com.example.demo.product.entity;

import cn.easyes.annotation.HighLight;
import cn.easyes.annotation.IndexField;
import cn.easyes.annotation.IndexId;
import cn.easyes.annotation.IndexName;
import cn.easyes.annotation.rely.Analyzer;
import cn.easyes.annotation.rely.FieldType;
import cn.easyes.annotation.rely.IdType;
import lombok.Data;

import java.util.Date;

/**
 * 车票产品扩展信息表
 *  product_train
 */
@IndexName(value ="train",shardsNum = 3,replicasNum = 2)
@Data
public class ProductTrainEntity {
    /**
     * 车票产品ID
     */
    @IndexId(type = IdType.CUSTOMIZE)
    private Long id;

    /**
     * 关联产品主表ID
     */
    @IndexField(fieldType = FieldType.LONG)
    private Long productId;

    /**
     * 车次
     */
    @IndexField(fieldType = FieldType.KEYWORD)
    private String trainNo;

    /**
     * 出发站
     */
    @HighLight(mappingField = "highlightContent")
    @IndexField(fieldType = FieldType.TEXT,analyzer = Analyzer.IK_MAX_WORD,searchAnalyzer = Analyzer.IK_SMART)
    private String departureStation;

    /**
     * 到达站
     */
    @HighLight(mappingField = "highlightContent")
    @IndexField(fieldType = FieldType.TEXT,analyzer = Analyzer.IK_MAX_WORD,searchAnalyzer = Analyzer.IK_SMART)
    private String arrivalStation;

    /**
     * 出发时间
     */
    @IndexField(fieldType = FieldType.DATE)
    private Date departureTime;

    /**
     * 到达时间
     */
    @IndexField(fieldType = FieldType.DATE)
    private Date arrivalTime;
}