package com.example.demo.product.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.HttpUtils;
import com.example.demo.product.domain.ProductFlight;
import com.example.demo.product.esmapper.ProductFlightEsMapper;
import com.example.demo.product.service.ProductFlightService;
import com.example.demo.product.dao.ProductFlightMapper;
import com.example.demo.user.vo.ResultVo;
import org.apache.http.HttpResponse;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;

/**
* @author 徐乐
* @description 针对表【product_flight(机票产品扩展信息表)】的数据库操作Service实现
* @createDate 2025-06-10 20:12:01
*/
@Service
public class ProductFlightServiceImpl extends ServiceImpl<ProductFlightMapper, ProductFlight>
    implements ProductFlightService{
    @Autowired
    private ProductFlightEsMapper productFlightEsMapper;

//    @Override
//    public ResultVo flightSyncDataToEs() {
//        //创建索引
//        productFlightEsMapper.createIndex();
//        List<ProductFlight> flightList = this.list();
//        List<ProductFlightEntity> productFlightEntityList = new ArrayList<>();
//        for (ProductFlight productFlight : flightList) {
//            ProductFlightEntity productFlightEntity = new ProductFlightEntity();
//            productFlightEntity.setId(productFlight.getId());
//            productFlightEntity.setProductId(productFlight.getProductId());
//            productFlightEntity.setFlightNo(productFlight.getFlightNo());
//            productFlightEntity.setDepartureAirport(productFlight.getDepartureAirport());
//            productFlightEntity.setArrivalAirport(productFlight.getArrivalAirport());
//            productFlightEntity.setDepartureTime(productFlight.getDepartureTime());
//            productFlightEntity.setArrivalTime(productFlight.getArrivalTime());
//            productFlightEntity.setSeatType(productFlight.getSeatType());
//            productFlightEntityList.add(productFlightEntity);
//        }
//        productFlightEsMapper.insertBatch(productFlightEntityList);
//        return ResultVo.success("同步数据成功");
//    }
//
//    @Override
//    public ResultVo getFlightList(String token) {
//        Long userId = TokenUtils.getUserId(token);
//        if (userId==null){
//            return ResultVo.error(101,"请先登录");
//        }
//        LambdaEsQueryWrapper<ProductFlightEntity> wrapper = new LambdaEsQueryWrapper();
//        EsPageInfo<ProductFlightEntity> pageInfo = productFlightEsMapper.pageQuery(wrapper,1,20);
//        return ResultVo.success(pageInfo);
//    }

    @Override
    public ResultVo getFlight(String token, String endCity, String endDate,String startCity, String startDate) {
        //API产品路径
        String host = "http://plane.market.alicloudapi.com";
        String path = "/ai_market/ai_airplane/get_airplane_list";
        String method = "GET";
        //阿里云APPCODE
        String appcode = "a1595e6d28984e07ba4f939fa53ccb55";
        Map<String, String> headers = new HashMap<String, String>();
        headers.put("Authorization", "APPCODE " + appcode);
        Map<String, String> querys = new HashMap<String, String>();
        //参数配置
        //抵达城市，如：上海
        querys.put("END_CITY", endCity);
        //返程日期，如：20190208，若无返回日期，则填写出发日期
        querys.put("END_DATE", endDate);
        //出发城市，如：北京
        querys.put("START_CITY", startCity);
        //出发日期，如：20190208
        querys.put("START_DATE", startDate);

        try {
            /**
             * 重要提示如下:
             * HttpUtils请从
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/src/main/java/com/aliyun/api/gateway/demo/util/HttpUtils.java
             * 下载
             *
             * 相应的依赖请参照
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/pom.xml
             */
            HttpResponse response = HttpUtils.doGet(host, path, method, headers, querys);
            int statusCode = response.getStatusLine().getStatusCode();

            // 检查HTTP状态码
            if (statusCode != 200) {
                return ResultVo.error("API请求失败，状态码：" + statusCode);
            }

            // 解析响应体
            String responseBody = EntityUtils.toString(response.getEntity(), StandardCharsets.UTF_8);
            System.out.println("API原始响应：" + responseBody);

            // 直接返回API的原始JSON数据（或按需解析后返回）
            return ResultVo.success(responseBody);

        } catch (Exception e) {
            e.printStackTrace();
            return ResultVo.error("调用航班API时出错：" + e.getMessage());
        }
    }
}




