package com.example.demo.product.service.impl;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.product.domain.ProductHotel;
import com.example.demo.product.entity.ProductHotelEntity;
import com.example.demo.product.esmapper.ProductHotelEsMapper;
import com.example.demo.product.service.ProductHotelService;
import com.example.demo.product.dao.ProductHotelMapper;
import com.example.demo.user.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
* @author 徐乐
* @description 针对表【product_hotel(酒店产品扩展信息表)】的数据库操作Service实现
* @createDate 2025-06-17 08:56:49
*/
@Service
public class ProductHotelServiceImpl extends ServiceImpl<ProductHotelMapper, ProductHotel>
    implements ProductHotelService{

    @Autowired
    private ProductHotelEsMapper productHotelEsMapper;
    @Override
    public ResultVo hotelSyncDataToEs() {
        productHotelEsMapper.createIndex();
        List<ProductHotel> hotelList = this.list();
        List<ProductHotelEntity> productHotelEntityList = new ArrayList<>();
        for (ProductHotel productHotel : hotelList) {
            ProductHotelEntity productHotelEntity = new ProductHotelEntity();
            productHotelEntity.setId(productHotel.getId());
            productHotelEntity.setProductId(productHotel.getProductId());
            productHotelEntity.setHotelName(productHotel.getHotelName());
            productHotelEntity.setRoomType(productHotel.getRoomType());
            productHotelEntity.setAddress(productHotel.getAddress());
            productHotelEntity.setCheckinTime(productHotel.getCheckinTime());
            productHotelEntity.setCheckoutTime(productHotel.getCheckoutTime());
            productHotelEntityList.add(productHotelEntity);
        }
        productHotelEsMapper.insertBatch(productHotelEntityList);
        return ResultVo.success("数据同步成功");
    }

    @Override
    public ResultVo getHotelList(String token) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        LambdaEsQueryWrapper<ProductHotelEntity> wrapper = new LambdaEsQueryWrapper<>();
        EsPageInfo<ProductHotelEntity> pageInfo = productHotelEsMapper.pageQuery(wrapper, 1, 20);
        return ResultVo.success(pageInfo);
    }
}




