package com.example.demo.product.service.impl;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.demo.common.utils.TokenUtils;
import com.example.demo.product.domain.ProductTrain;
import com.example.demo.product.dto.TrainDto;
import com.example.demo.product.entity.ProductTrainEntity;
import com.example.demo.product.esmapper.ProductTrainEsMapper;
import com.example.demo.product.service.ProductTrainService;
import com.example.demo.product.dao.ProductTrainMapper;
import com.example.demo.user.vo.ResultVo;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
* @author 徐乐
* @description 针对表【product_train(车票产品扩展信息表)】的数据库操作Service实现
* @createDate 2025-06-10 20:12:01
*/
@Service
public class ProductTrainServiceImpl extends ServiceImpl<ProductTrainMapper, ProductTrain>
    implements ProductTrainService{
    @Autowired
    private ProductTrainEsMapper productTrainEsMapper;

//    @Override
//    public ResultVo trainSyncDataToEs() {
//        //创建索引
//        productTrainEsMapper.createIndex();
//        List<ProductTrain> trainList = this.list();
//        List<ProductTrainEntity> productTrainEntityList = new ArrayList<>();
//        for (ProductTrain productTrain : trainList) {
//            ProductTrainEntity productTrainEntity = new ProductTrainEntity();
//            productTrainEntity.setId(productTrain.getId());
//            productTrainEntity.setProductId(productTrain.getProductId());
//            productTrainEntity.setTrainNo(productTrain.getTrainNo());
//            productTrainEntity.setDepartureStation(productTrain.getDepartureStation());
//            productTrainEntity.setArrivalStation(productTrain.getArrivalStation());
//            productTrainEntity.setDepartureTime(productTrain.getDepartureTime());
//            productTrainEntity.setArrivalTime(productTrain.getArrivalTime());
//            productTrainEntityList.add(productTrainEntity);
//        }
//        productTrainEsMapper.insertBatch(productTrainEntityList);
//        return ResultVo.success("同步数据成功");
//    }
//
//    @Override
//    public ResultVo getTrainList(String token) {
//        Long userId = TokenUtils.getUserId(token);
//        if (userId==null){
//            return ResultVo.error(101,"请先登录");
//        }
//        LambdaEsQueryWrapper<ProductTrainEntity> wrapper = new LambdaEsQueryWrapper<>();
//        EsPageInfo<ProductTrainEntity> pageInfo = productTrainEsMapper.pageQuery(wrapper, 1, 20);
//        return ResultVo.success(pageInfo);
//    }

    @Override
    public ResultVo getTrain(String token, HttpResponse response, TrainDto dto) {
        Long userId = TokenUtils.getUserId(token);
        if (userId==null){
            return ResultVo.error(101,"请先登录");
        }
        String host = "https://jisutrain.market.alicloudapi.com";
        String path = "/train/ticket";
        String method = "ANY";
        String appcode = "a1595e6d28984e07ba4f939fa53ccb55";
        Map<String, String> headers = new HashMap<String, String>();
        //最后在header中的格式(中间是英文空格)为Authorization:APPCODE 83359fd73fe94948385f570e3c139105
        headers.put("Authorization", "APPCODE " + appcode);
        //根据API的要求，定义相对应的Content-Type
        headers.put("Content-Type", "application/json; charset=UTF-8");
        Map<String, String> querys = new HashMap<String, String>();
        querys.put("date", dto.getDate());
        querys.put("end", dto.getEnd());
        querys.put("start", dto.getStart());


        try {
            /**
             * 重要提示如下:
             * HttpUtils请从
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/src/main/java/com/aliyun/api/gateway/demo/util/HttpUtils.java
             * 下载
             *
             * 相应的依赖请参照
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/pom.xml
             */

            System.out.println(response.toString());
            // 构建请求URI
            URIBuilder uriBuilder = new URIBuilder(host + path);
            for (Map.Entry<String, String> entry : querys.entrySet()) {
                uriBuilder.addParameter(entry.getKey(), entry.getValue());
            }

            // 创建HTTP客户端和请求
            HttpClient httpClient = HttpClients.createDefault();
            HttpPost httpPost = new HttpPost(uriBuilder.build());

            // 设置请求头
            for (Map.Entry<String, String> entry : headers.entrySet()) {
                httpPost.setHeader(entry.getKey(), entry.getValue());
            }

            // 执行请求
            HttpResponse response1 = httpClient.execute(httpPost);

            // 处理响应
            if (response1.getStatusLine().getStatusCode() == 200) {
                String responseBody = EntityUtils.toString(response1.getEntity(), "UTF-8");
                System.out.println("API返回结果:");
                System.out.println(responseBody);
                return ResultVo.success(responseBody);
            } else {
                System.out.println("请求失败，状态码: " + response1.getStatusLine().getStatusCode());
                System.out.println(EntityUtils.toString(response1.getEntity(), "UTF-8"));
                return ResultVo.error(response1.getStatusLine().getStatusCode(),"请求失败");
            }
        } catch (Exception e) {
            e.printStackTrace();
            return ResultVo.error();
        }
//            //获取response的body
////            System.out.println(EntityUtils.toString(response.getEntity(),"utf-8"));
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }
}




